# C3D2 NixOS user module

NixOS module intended to be used by people regularly visiting C3D2 and wanting to stream audio, have a filled known_host's file, etc.

## Usage

Add or merge the following settings to your `flake.nix`:

```nix
{
  inputs = {
    c3d2-user-module.url = "git+https://gitea.c3d2.de/C3D2/nix-user-module.git";
  };

  outputs = { c3d2-user-module }: {
    nixosConfigurations.HOSTNAME = {
      modules = [
        c3d2-user-module.nixosModule
    ];
  };
}
```

## Options

- `c3d2.addKnownHosts`: set to true to add the public ssh host keys to the known_hosts file.
- `c3d2.audioStreaming`: set to true to enable all services to audio stream to pulsebert, dacbert or glotzbert in hq.
  After enabling this option run ``systemctl --user restart pulseaudio`` or ``systemctl --user restart pipewire-pulse``.
  If that is not working logout of your session and log back in.
- `c3d2.addBinaryCache`: set to true to add the [c3d2 hydra](https://hydra.hq.c3d2.de/) as permanent trusted-substituter.

## Design

- Modules should never change the configuration without setting an option

## Structure

This is based on [sandro's nixos-modules (on GitHub)](https://github.com/superSandro2000/nixos-modules) and follows the same structure and design.
